import java.awt.image.RGBImageFilter;

// ÉtB^
class DarkerFilter extends RGBImageFilter
{
	// É̓x(傫قǈÂȂ)
	double rate;

	public DarkerFilter(double rate)
	{
		// ratẽm[}CY
		if(rate > 1.0)
			rate = 1.0;
		if(rate < 0.0)
			rate = 0.0;
		this.rate = rate;

		canFilterIndexColorModel = true;
	}

	public int filterRGB(int x,int y,int rgb)
	{
		// eRGBl̎擾
		int alpha_value = (rgb & 0xff000000);
		int red_value   = (rgb & 0x00ff0000) >> 16;
		int green_value = (rgb & 0x0000ff00) >> 8;
		int blue_value  = (rgb & 0x000000ff);

		// É
		red_value   = (int)(red_value   * (1 - rate));
		green_value = (int)(green_value * (1 - rate));
		blue_value  = (int)(blue_value  * (1 - rate));

		return(alpha_value | (red_value << 16) | (green_value  << 8) | blue_value);
	}
}