import java.awt.image.RGBImageFilter;

// tB^
class BrighterFilter extends RGBImageFilter
{
	final int RGB_MAX = 255;
	// ̓x(傫قǖ邭Ȃ)
	double rate;
	int hosei;

	public BrighterFilter(double rate)
	{
		// ratẽm[}CY
		if(rate > 1.0)
			rate = 1.0;
		if(rate < 0.0)
			rate = 0.0;
		this.rate = rate;

		hosei = (int)(RGB_MAX * rate);
		canFilterIndexColorModel = true;
	}

	public int filterRGB(int x,int y,int rgb)
	{
		// eRGBl̎擾
		int alpha_value = (rgb & 0xff000000);
		int red_value   = (rgb & 0x00ff0000) >> 16;
		int green_value = (rgb & 0x0000ff00) >> 8;
		int blue_value  = (rgb & 0x000000ff);

		// 
		red_value   = (int)(red_value   * (1 - rate)) + hosei;
		green_value = (int)(green_value * (1 - rate)) + hosei;
		blue_value  = (int)(blue_value  * (1 - rate)) + hosei;

		return(alpha_value | (red_value << 16) | (green_value  << 8) | blue_value);
	}
}