import java.awt.event.*;
import java.awt.*;
import java.awt.image.FilteredImageSource;
import java.awt.image.RGBImageFilter;

class filter
{
	public static void main(String args[])
	{
		new MainWindow(args[0],Double.parseDouble(args[1]));
	}
}

class MainWindow extends Frame
{
	public MainWindow(String image_name,double rate)
	{
		// WindowXi̓o^
		WindowListener listener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		};
		addWindowListener(listener);

		setLayout(new BorderLayout());

		// C[W̎擾
		Toolkit toolkit = getToolkit();
		Image src = toolkit.getImage(image_name);

		// C[W̃tB^O
		RGBImageFilter filter;
		if(rate >= 0)
			filter = new BrighterFilter(Math.abs(rate));
		else
			filter = new DarkerFilter(Math.abs(rate));
		Image image = createImage(new FilteredImageSource(src.getSource(),filter));

		// R|[lg̒ǉ
		PaintCanvas canvas = new PaintCanvas(image);
		add(canvas,BorderLayout.CENTER);

		Label lbl = new Label(image_name,Label.CENTER);
		add(lbl,BorderLayout.SOUTH);

		// t[̏ݒ
		setSize(150,150);
		setTitle("Image Filter");
		setVisible(true);
	}
}

// C[W\pLoX
class PaintCanvas extends Canvas
{
	Image image;

	public PaintCanvas(Image image)
	{
		this.image = image;
	}

	public void paint(Graphics g)
	{
		g.drawImage(image,0,0,this);
	}
}